﻿using System;
using System.Reflection;

namespace MyMapper.Demo
{
    class Program
    {
        static void Main()
        {
            Console.WriteLine("MyMapper demo application\r\n");
            Console.WriteLine("1. Create source object (press enter)");
            Console.ReadLine();

            var orderDto = new OrderDto
                               {
                                   Id = 1,
                                   CustomerName = "The Very Big Corporation of America",
                                   OrderDate = DateTime.Now.Date,
                                   OrderNo = "PO-13393",
                                   OrderNotes = "One hundred containers of Coca-Cola"
                               };
            Console.WriteLine("   OrderDto:");
            foreach (PropertyInfo prop in orderDto.GetType().GetProperties())
                Console.WriteLine("   " + prop.Name + ": " + prop.GetValue(orderDto, null));

            Console.WriteLine("\r\nPress any key to continue...\r\n");
            Console.ReadKey();

            Console.WriteLine("2. Create target object (press enter)");
            Console.ReadKey();

            var customer = new Customer
                               {
                                   Id = 3,
                                   Name = "another great customer"
                               };
            var order = new Order
                            {
                                Id = 2,
                                Customer = customer, 
                                OrderDate = DateTime.Now.Date.AddDays(-5), 
                                OrderNo = "PO-12292",
                                OrderNotes = "Some color pencils"
                            };

            Console.WriteLine("   Order:");
            foreach (PropertyInfo prop in order.GetType().GetProperties())
                Console.WriteLine("   " + prop.Name + ": " + prop.GetValue(order, null));

            Console.WriteLine("\r\nPress any key to continue...\r\n");
            Console.ReadKey();
            Console.WriteLine("3. Create mapping and copy properties (press enter)");
            Console.ReadKey();

            var mapper = new Mapper();
            mapper.MapTypes<OrderDto, Order>();
            mapper.Copy(orderDto, order);

            Console.WriteLine("   Order properties after copying");
            foreach (PropertyInfo prop in order.GetType().GetProperties())
                Console.WriteLine("   " + prop.Name + ": " + prop.GetValue(order, null));

            Console.WriteLine("\r\nPress any key to exit...");
            Console.ReadKey();
        }
    }
}
